-- 
-- DRB200 - Event
-- 
-- @Author: E.T.A La Marchoise
-- @Date: 12.12.2020
-- @EndDate: 07.01.2020
-- @Version: 1.0.0.0
-- 
-- @Support: facebook.com/E.T.ALaMarchoise
-- 

DRB200Event = {};
DRB200Event_mt = Class(DRB200Event, Event);

InitEventClass(DRB200Event, "DRB200Event");

function DRB200Event:emptyNew()
	local self = Event:new(DRB200Event_mt);
    
	return self;
end

function DRB200Event:new(drb200, fillTypeIndex, baleIsSpawned)
	local self = DRB200Event:emptyNew();
	
	self.drb200 = drb200;
	self.fillTypeIndex = fillTypeIndex;
	self.baleIsSpawned = baleIsSpawned;
	
	return self;
end

function DRB200Event:readStream(streamId, connection)
	self.drb200 = NetworkUtil.readNodeObject(streamId);
	self.baleIsSpawned = streamReadBool(streamId);
	self.fillTypeIndex = streamReadInt8(streamId);

	self:run(connection);
end

function DRB200Event:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.drb200);
	streamWriteBool(streamId, self.baleIsSpawned);
	streamWriteInt8(streamId, self.fillTypeIndex);
end

function DRB200Event:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(DRB200Event:new(self.drb200, self.fillTypeIndex, self.baleIsSpawned), nil, connection, self.drb200)
	end

	self.drb200:spawnBale(self.fillTypeIndex, true);
end

function DRB200Event.sendEvent(drb200, fillTypeIndex, baleIsSpawned, noEventSend)
	if noEventSend == nil or noEventSend == false then
		local event = DRB200Event:new(drb200, fillTypeIndex, baleIsSpawned);
		
		if g_currentMission:getIsServer() then
			g_server:broadcastEvent(event, false)
		else
			g_client:getServerConnection():sendEvent(event)
		end
	end
end